Перем Результат; // Массив из Строка

#Область ПрограммныйИнтерфейс

Функция ПолучитьРезультат() Экспорт
	Возврат СокрЛП(СтрСоединить(Результат));
КонецФункции

Функция Пустой() Экспорт
	Возврат Результат.Количество() = 0;
КонецФункции

Функция Очистить() Экспорт
	Результат.Очистить();
	Возврат ЭтотОбъект;
КонецФункции

Функция ДобавитьСтроку(Строка, 
	Значение1 = Неопределено, Значение2 = Неопределено, Значение3 = Неопределено) Экспорт

	Результат.Добавить(Символы.ПС);
	Результат.Добавить(СтрШаблон(Строка, Значение1, Значение2, Значение3));

	Возврат ЭтотОбъект;

КонецФункции

Функция ДобавитьКомментарий(Строка, 
	Значение1 = Неопределено, Значение2 = Неопределено, Значение3 = Неопределено) Экспорт

	Возврат ДобавитьСтроку("// " + Строка, Значение1, Значение2, Значение3);

КонецФункции

Функция ДобавитьПустуюСтроку(ТолькоПриОтсутствии = Истина) Экспорт

	ИндексПоследнего = Результат.ВГраница();

	Если ИндексПоследнего >= 0 И Не Результат[ИндексПоследнего] = Символы.ПС 
		Или Не ТолькоПриОтсутствии Тогда
		Результат.Добавить(Символы.ПС);
	КонецЕсли;

	Возврат ЭтотОбъект;

КонецФункции

Функция ПараметрыФункцииВСтроку(ПараметрыФункции) Экспорт
	
	ПараметрыСтрокой = "";
	МаксимальнаяДлинаВсехПараметровНаОднойСтроке = 110;

	ДлинаПараметров = СтрДлина(СтрСоединить(ПараметрыФункции, ", ")) ;
	ПереноситьКаждыйПараметр = ДлинаПараметров > МаксимальнаяДлинаВсехПараметровНаОднойСтроке;

	Если ПереноситьКаждыйПараметр Тогда
		Разделитель = "," + Символы.ПС + Символы.Таб;
	Иначе
		Разделитель = ", ";
	КонецЕсли;

	КоличествоПараметров = ПараметрыФункции.Количество();

	ЕстьЗаполненный = Ложь;
	Для Инд = 1 По КоличествоПараметров Цикл
		
		Значение = ПараметрыФункции[КоличествоПараметров - Инд];

		Если ТипЗнч(Значение) <> Тип("Строка") Тогда
			Значение = ПараметрВСтроку(Значение);
		КонецЕсли;

		Если Не ЕстьЗаполненный И Не ЗначениеЗаполнено(Значение) Тогда
			Продолжить;
		КонецЕсли;

		ПараметрыСтрокой = Значение + ?(ПараметрыСтрокой = "", "", Разделитель) + ПараметрыСтрокой;

		ЕстьЗаполненный = Истина;

	КонецЦикла;

	Возврат СокрЛП(ПараметрыСтрокой);

КонецФункции

Функция ПараметрВСтроку(Значение) Экспорт

	Тип = ТипЗнч(Значение);
	Если Тип = Тип("Строка") Тогда

		Возврат СтрШаблон("""%1""", ЭкранироватьКавычки(Значение));

	ИначеЕсли Тип = Тип("Число") Тогда

		Возврат Формат(Значение, "ЧРД=.; ЧН=0; ЧГ=");

	ИначеЕсли Тип = Тип("Булево") Тогда

		Возврат Формат(Значение, "БЛ=Ложь; БИ=Истина");

	ИначеЕсли Тип = Тип("Дата") Тогда

		Если НачалоДня(Значение) = Значение Тогда
			Возврат Формат(Значение, "ДФ='''Дата(''yyyy, M, d'')'''");
		Иначе
			Возврат Формат(Значение, "ДФ='''Дата(''yyyy, M, d, H, m, s'')'''");
		КонецЕсли;

	Иначе

		Возврат "";

	КонецЕсли;

КонецФункции

Функция НеобязательныйПараметрВСтроку(Значение) Экспорт

	Если ЗначениеЗаполнено(Значение) Тогда
		Возврат ПараметрВСтроку(Значение);
	КонецЕсли;

	Возврат "";

КонецФункции

Функция ДобавитьСоответствие(Соответствие, ИмяПараметра) Экспорт
	
	ДобавитьСтроку("%1 = Новый Соответствие();", ИмяПараметра);

	ДобавитьЭлементыСоответствия(Соответствие, ИмяПараметра);

	Возврат ЭтотОбъект;

КонецФункции

Функция ДобавитьЭлементыСоответствия(Соответствие, ИмяПараметра) Экспорт
	
	Для Каждого КлючИЗначение Из Соответствие Цикл

		ТипЗначения = ТипЗнч(КлючИЗначение.Значение);
		Если ТипЗначения = Тип("Соответствие") Тогда

			ДобавитьСтроку(
				"%1.{t(Соответствие.Вставить)}(%2, Новый Соответствие());",
				ИмяПараметра,
				ПараметрВСтроку(КлючИЗначение.Ключ)
			);

			Путь = СтрШаблон("%1[""%2""]", ИмяПараметра, КлючИЗначение.Ключ);
			ДобавитьЭлементыСоответствия(КлючИЗначение.Значение, Путь);

		ИначеЕсли ТипЗначения = Тип("Массив") Тогда

			ДобавитьСтроку(
				"%1.{t(Соответствие.Вставить)}(%2, Новый Массив());",
				ИмяПараметра,
				ПараметрВСтроку(КлючИЗначение.Ключ)
			);

			Путь = СтрШаблон("%1[""%2""]", ИмяПараметра, КлючИЗначение.Ключ);
			ДобавитьЭлементыМассива(КлючИЗначение.Значение, Путь);

		Иначе
		
			МассивПараметров = Новый Массив();
			МассивПараметров.Добавить(ПараметрВСтроку(КлючИЗначение.Ключ));
			МассивПараметров.Добавить(ПараметрВСтроку(КлючИЗначение.Значение));

			ДобавитьСтроку(
				"%1.{t(Соответствие.Вставить)}(%2);",
				ИмяПараметра,
				ПараметрыФункцииВСтроку(МассивПараметров)
			);

		КонецЕсли;

	КонецЦикла;

	Возврат ЭтотОбъект;

КонецФункции

Функция ДобавитьМассив(Массив, ИмяПараметра) Экспорт
	
	ДобавитьСтроку("%1 = Новый Массив();", ИмяПараметра);

	ДобавитьЭлементыМассива(Массив, ИмяПараметра);

	Возврат ЭтотОбъект;

КонецФункции

Функция ДобавитьЭлементыМассива(Массив, ИмяПараметра) Экспорт

	ИндексЭлемента = 0;

	Для Каждого Значение Из Массив Цикл

		ТипЗначения = ТипЗнч(Значение);
		Если ТипЗначения = Тип("Соответствие") Тогда

			ДобавитьСтроку("%1.{t(Массив.Добавить)}(Новый Соответствие());", ИмяПараметра);

			Путь = СтрШаблон("%1[%2]", ИмяПараметра, Формат(ИндексЭлемента, "ЧН=0; ЧГ="));
			ДобавитьЭлементыСоответствия(Значение, Путь);

		ИначеЕсли ТипЗначения = Тип("Массив") Тогда

			ДобавитьСтроку("%1.{t(Массив.Добавить)}(Новый Массив());", ИмяПараметра);

			Путь = СтрШаблон("%1[%2]", ИмяПараметра, Формат(ИндексЭлемента, "ЧН=0; ЧГ="));
			ДобавитьЭлементыМассива(Значение, Путь);

		Иначе

			ДобавитьСтроку("%1.{t(Массив.Добавить)}(%2);", ИмяПараметра, ПараметрВСтроку(Значение));

		КонецЕсли;

		ИндексЭлемента = ИндексЭлемента + 1;

	КонецЦикла;

	Возврат ЭтотОбъект;

КонецФункции

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

Процедура ПриСозданииОбъекта()
	Результат = Новый Массив();
КонецПроцедуры

Функция ЭкранироватьКавычки(Знач Строка)
	Строка = СтрЗаменить(Строка, """", """""");
	Строка = СтрЗаменить(Строка, Символы.ПС, Символы.ПС + "|");
	Возврат Строка;
КонецФункции

#КонецОбласти